<!-- eslint-disable vue/no-v-html -->
<template>
  <div class="relative-position">
    <q-card
      id="composition"
      class="composition-view"
      v-html="composing.doc"
    />

    <div class="title-area" />

    <div
      class="numbering"
      v-html="numbering"
    />
  </div>
</template>

<script>
import { colors } from 'quasar'
import _ from 'lodash'

const { hexToRgb } = colors

export default {
  name: 'CompositionView',
  props: {
    composing: {
      type: Object,
      required: true
    }
  },
  computed: {
    numbering () {
      let numbers = ''

      for (let i = 1; i <= 30; i++) {
        numbers += `<div>${i}.</div>`
      }

      return numbers
    }
  },
  updated () {
    this.html()
  },
  methods: {
    hex2rgb (hexColor) {
      try {
        const { r, g, b } = hexToRgb(hexColor)
        return `rgb(${r}, ${g}, ${b})`
      } catch (e) {
        return hexColor
      }
    },
    html () {
      const html = document.getElementById('composition')
      const spanElements = html.getElementsByTagName('span')
      const pElements = html.getElementsByTagName('p')
      const keys = _(this.composing.comments)
        .map(({ id = '_' }) => {
          const [tempSelected, tempColor] = id.split('_')

          return (tempSelected && tempColor)
            ? `${_.snakeCase(tempSelected)}_${this.hex2rgb(tempColor).replace(/\D/g, '')}`
            : undefined
        })
        .compact()
        .value()

      for (let i = 0; i < spanElements.length; i++) {
        const span = spanElements[i]
        const color = span.style.backgroundColor.replace(/\D/g, '')
        const key = `${_.snakeCase(span.textContent)}_${color}`
        const id = keys.includes(key) ? key : _.snakeCase(span.textContent)

        span.setAttribute('id', id)
        span.addEventListener('mouseover', ({ target }) => {
          const info = keys.includes(key) ? `${target.textContent}_${color}` : target.textContent

          this.$emit('info', info)
        })
      }

      for (let i = 0; i < pElements.length; i++) {
        const p = pElements[i]
        const indent = p.getAttribute('data-indent')

        p.style.margin = 0

        if (indent) {
          p.style.textIndent = `calc(32px * ${indent})`
        }
      }
    }
  }
}
</script>
